//
//  GifHandeler.swift
//  BRKN_ESC
//
//  Created by Andre Mendez on 2/1/20.
//  Copyright © 2020 Andre Mendez. All rights reserved.
//

import Foundation
import SpriteKit

class GifHandeler: SKNode{
    private var atlas: SKTextureAtlas
    private var image = SKSpriteNode()
    private var imageAnimFrames: [SKTexture] = [];
    private var firstFrameTexture: SKTexture = SKTexture()
    private var timeInerval: Double
    //private var scene: SKScene
    
    init(scene: SKScene, atlasName: String, time: Double){
    self.atlas = SKTextureAtlas(named: atlasName)
        self.timeInerval = time
       // self.scene = scene;
    super.init()
    
    self.name = atlasName
    buildImage()

    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }

    func setImagePosition(pos: CGPoint){
        image.position = pos
    }

    func buildImage(){
        var animFrames:[SKTexture] = [];
        
        let numImages = atlas.textureNames.count;
        for i in 0...numImages - 1 {
            let logotex = "\(i)"
            animFrames.append(atlas.textureNamed(logotex));
        }
        imageAnimFrames = animFrames;
        
        firstFrameTexture = imageAnimFrames[0];
        
        
        image = SKSpriteNode(texture: firstFrameTexture);
        
        animateImage()
        addChild(image);
        
        }

    func animateImage(){
        image.run(SKAction.repeatForever(
            SKAction.animate(with: imageAnimFrames, timePerFrame: timeInerval, resize: false, restore: true)))
    }
}
