//
//  HUD.swift
//  BRKN_ESC
//
//  Created by Andre Mendez on 2/1/20.
//  Copyright © 2020 Andre Mendez. All rights reserved.
//

import Foundation
import SpriteKit

class HUD: SKNode{
    
    let UIArrowDown = SKSpriteNode(imageNamed: "UIArrowDown")
    let UIArrowRight = SKSpriteNode(imageNamed: "UIArrowRight")
    let UIArrowUp = SKSpriteNode(imageNamed: "UIArrowUp")
    let UIArrowLeft = SKSpriteNode(imageNamed: "UIArrowLeft")
    let actionButton = SKSpriteNode(imageNamed: "circlebig")
    
    
    
    
    override init(){
     super.init()
     
     self.name = "HUD"

     }
     
     required init?(coder aDecoder: NSCoder) {
         fatalError("init(coder:) has not been implemented")
    }
    
    func setImages(pos: CGPoint, scene: SKScene){
        UIArrowLeft.position = CGPoint(x: pos.x + 100, y: pos.y)
        UIArrowLeft.name = "leftArrow"
        UIArrowLeft.zPosition = 20
        UIArrowLeft.scale(to: CGSize(width: UIArrowLeft.size.width * 2, height: UIArrowLeft.size.height * 2))
        
        UIArrowUp.position = CGPoint(x: pos.x  + UIArrowLeft.size.width + 100, y: pos.y)
        UIArrowUp.name = "upArrow"
        UIArrowUp.zPosition = 20
        UIArrowUp.scale(to: CGSize(width: UIArrowUp.size.width * 2, height: UIArrowUp.size.height * 2))
        
        UIArrowDown.position = CGPoint(x: pos.x + (UIArrowUp.size.width * 2) + 100 , y: pos.y)
        UIArrowDown.name = "downArrow"
        UIArrowDown.zPosition = 20
        UIArrowDown.scale(to: CGSize(width: UIArrowDown.size.width * 2, height: UIArrowDown.size.height * 2))
        
        UIArrowRight.position = CGPoint(x: pos.x + (UIArrowDown.size.width * 3) + 100, y: pos.y)
        UIArrowRight.name = "rightArrow"
        UIArrowRight.zPosition = 20
        UIArrowRight.scale(to: CGSize(width: UIArrowRight.size.width * 2, height: UIArrowRight.size.height * 2))
        
        actionButton.position = CGPoint(x: pos.x + (UIArrowRight.size.width * 4) + 100, y: pos.y)
        actionButton.name = "actionButton"
        actionButton.zPosition = 20
        //actionButton.scale(to: CGSize(width: actionButton.size.width * 2, height: actionButton.size.height * 2))
        
        scene.addChild(UIArrowLeft)
        scene.addChild(UIArrowUp)
        scene.addChild(UIArrowDown)
        scene.addChild(UIArrowRight)
        scene.addChild(actionButton)
    }
    
    func updatePosition(newPos: CGPoint){
        UIArrowLeft.position.x = newPos.x + 50;
        UIArrowLeft.position.y = newPos.y;
        
        UIArrowDown.position.x = newPos.x + (UIArrowUp.size.width) + 50;
        UIArrowDown.position.y = newPos.y;
        
        UIArrowUp.position.x = newPos.x  + (UIArrowUp.size.width * 2) + 50;
        UIArrowUp.position.y = newPos.y;
        
        UIArrowRight.position.x = newPos.x  + (UIArrowUp.size.width * 3) + 50;
        UIArrowRight.position.y = newPos.y;
        
        actionButton.position.x = newPos.x  + (UIArrowUp.size.width * 4) + 100;
        actionButton.position.y = newPos.y;
        
    }
}
