//
//  GameScene.swift
//  BRKN_ESC
//
//  Created by Andre Mendez on 1/31/20.
//  Copyright © 2020 Andre Mendez. All rights reserved.
//

import SpriteKit
import GameplayKit

class GameScene: SKScene {
    
        var startLable:SKLabelNode = SKLabelNode();
        let gameWorld = GameWorld(fileNamed: "GameWorld");
        
        
        override func didMove(to view: SKView) {
            let logo = GifHandeler(scene: self, atlasName: "Logo", time: 0.7)
            logo.setImagePosition(pos: CGPoint(x: 40, y: 40))
            
            
            if let someLable:SKLabelNode = self.childNode(withName: "startLabel") as? SKLabelNode{
                startLable = someLable;
            }
            addChild(logo)
            
            gameWorld?.scaleMode = .aspectFill
            
        }
        
        override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
            for touch in touches{
                
                let positionInScene = touch.location(in: self)
                let touchnode = self.nodes(at: positionInScene)
                print(touchnode)
                
                for nodeTouched in touchnode{
                    
                    if let name = nodeTouched.name{
                        if name ==  "Logo"{
                            print("Starting Game...")
                            self.view?.presentScene(gameWorld!, transition: SKTransition.fade(withDuration: 0.5))
                        }
                        if name == "exitLabel"{
                            print("Exiting Game...")
                        }
                    }
                }
                
            }
        }
    
    
}
