//
//  GameWorld.swift
//  BRKN_ESC
//
//  Created by Andre Mendez on 1/31/20.
//  Copyright © 2020 Andre Mendez. All rights reserved.
//

import Foundation
import SpriteKit

class GameWorld: SKScene {
    
    var cam: SKCameraNode?
    
    
    

    
    let player = Player();
    
    let hud = HUD();
    
    var touchLocation = CGPoint();
    
    
    

    
    override func didMove(to view: SKView) {
        //let background = scene?.childNode(withName: "background")
        
        let enemy1 = GifHandeler(scene: self, atlasName: "Enemy1", time: 0.3)
        enemy1.setImagePosition(pos: CGPoint(x: 400, y: -40))
        enemy1.physicsBody = SKPhysicsBody(rectangleOf: enemy1.frame.size)
        enemy1.physicsBody?.affectedByGravity = false
        enemy1.physicsBody?.pinned = true
        
        addChild(enemy1)
        
        let enemy2Attack = GifHandeler(scene: self, atlasName: "Enemy2", time: 0.4)
        enemy2Attack.setImagePosition(pos: CGPoint(x: -100, y: -300))
        addChild(enemy2Attack)
        
        let enemy2Idle = GifHandeler(scene: self, atlasName: "Enemy2Idle", time: 0.4)
        enemy2Idle.setImagePosition(pos: CGPoint(x: -450, y: -300))
        addChild(enemy2Idle)
        
        cam = SKCameraNode()
        
        hud.zPosition = 10

        
        self.camera = cam;
        let grect = CGRect(x: frame.minX, y: frame.minY, width: frame.width, height: (frame.height / 24));

        let ground = SKShapeNode(rect: grect);

        ground.physicsBody = SKPhysicsBody(edgeChainFrom: ground.path!);
        ground.physicsBody?.restitution = 0.75;
        addChild(ground);

        
        //background!.position.x = frame.midX;
        //background!.position.y = 120;
        //background!.scale(to: CGSize(width: 1024, height: 1024))
        //background!.zPosition = -1;
        //addChild(backGround);
        
        
        player.setUp(pos: CGPoint(x: 0, y: -100), scene: self)
        hud.setImages(pos: player.getPosition(), scene: self)
        
        
        
        addChild(cam!);
    }
    
    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
        
        /*
         Handle Player Movements
         */
        
        for touch in touches{
            let positionInScene = touch.location(in: self)
            let touchnode = self.nodes(at: positionInScene)
            //print(self.nodes(at: positionInScene))
            
            for nodeTouched in touchnode{
                
                
                if let name = nodeTouched.name{
                    if name == "leftArrow"{
                        print("Left Arrow")
                        player.moveLeft()
                    }
                    if name == "rightArrow"{
                        print("Right Arrow")
                        player.moveRight()
                    }
                    if name == "upArrow"{
                        print("Up Arrow")
                        player.moveUp()
                    }
                    if name == "downArrow"{
                        print("Down Arrow")
                        player.moveDown()
                    }

                }
            }
            
        }


    }
    
    override func update(_ currentTime: TimeInterval) {
        camera?.position = player.getPosition();
        //hud.setImages(pos: CGPoint(x:  camera!.position.x - 300, y: camera!.position.y - 200));
        hud.updatePosition(newPos: CGPoint(x: camera!.position.x - 300, y: camera!.position.y - 200))
        
        checkDoor(player: player, door: (scene?.childNode(withName: "door"))!)
    }
    
    
    func checkDoor(player: Player, door: SKNode){
        let contact = SKPhysicsContact()
        if (contact.bodyA.node?.name == "player" && contact.bodyB.node?.name == "door"){
            print("colided???????")
        }
        //print(door.frame.size)
        //door?.physicsBody = SKPhysicsBody(rectangleOf: door!.frame.size)
        //door?.physicsBody?.affectedByGravity = false
        //door?.physicsBody?.pinned = true
        door.physicsBody = SKPhysicsBody(rectangleOf: door.frame.size)
        door.physicsBody?.affectedByGravity = false
        door.physicsBody?.pinned = true
        door.zPosition = 3
        
        
        print(door.position)

        
        
        
    }
    
}
